import java.io.IOException;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
import org.apache.hadoop.util.GenericOptionsParser;
import org.apache.hadoop.fs.*;


public class WordCount_jdwang {

	public static void main(String[] args) throws IOException, InterruptedException, ClassNotFoundException {
				
		Configuration conf = new Configuration();
		
	  	conf.set("fs.default.name", "hdfs://localhost:9000");
	  	conf.set("mapred.job.tracker", "localhost:9001");
	    String[] otherArgs = null;
	    	    
		try {
			otherArgs = new GenericOptionsParser(conf, args).getRemainingArgs();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	    if (otherArgs.length != 2) {
	      System.err.println("Usage: wordcount <in> <out>");
	      System.exit(2);
	    }
	    Job job = new Job(conf, "word count (PubMedParsed) "+otherArgs[0]);
	    
	    job.setJarByClass(WordCount_jdwang.class);
	    
	    //job.setMapperClass(Mapper_jdwang.class);
	    //job.setMapperClass(Mapper1_jdwang.class);
	    //job.setMapperClass(Mapper2_jdwang.class);
	    //job.setMapperClass(Mapper3_jdwang.class);
	    //job.setMapperClass(Mapper4_jdwang.class); Mapper5Year_jdwang
	    job.setMapperClass(Mapper4a_jdwang.class);
	    //job.setMapperClass(Mapper5Year_jdwang.class); 
	    
	    
	    job.setReducerClass(Reducer_jdwang.class);
	    
	    job.setOutputKeyClass(Text.class);
	    job.setOutputValueClass(IntWritable.class);
	    
	    FileInputFormat.addInputPath(job, new Path(otherArgs[0]));	        
	    
	    FileSystem hdfs = FileSystem.get(conf);	    
	    Path outputPath = new Path(hdfs.getWorkingDirectory().toString() + "/"+args[1]);
	    FileOutputFormat.setOutputPath(job, outputPath);
	    
	    if(hdfs.exists(outputPath)) { 
	    	hdfs.delete(outputPath, true);
	    } 
	    hdfs.close();	    	    
	             
	    //System.exit(job.waitForCompletion(true) ? 0 : 1);
	  
	  	job.submit();
	  		
	  	if(job.waitForCompletion(true))
	  	{
	  		System.out.println("Job Done!");
	  		System.exit(0);
	  	}
	  	else
	  	{
	  		System.out.println("Job Failed!");
	  		System.exit(1);
	  	}    
	}
}
